#include <stdlib.h>
#include <stddef.h>
#include "myalloc.h"

#include <stdio.h>

// Start of heap
void * start_addr;

// Overall heap size in bytes
size_t heap_size;

struct header {
 size_t next;
 size_t inuse;
} ;

// Inits the allocator, by setting correct data about beginning of heap (the pointer p)
// and the size s of the heap
void init_myallocator(void *p, size_t s) {
	struct header * myheader;

	start_addr = p;
	heap_size  = s;
	
	myheader = p;
	myheader->next  = (size_t) 0;
	myheader->inuse = (size_t) 0;
	
	printf("The size of the header is %i\n", sizeof(struct header));
}

void * myalloc(size_t s) {
  // Your code here
 }


void myfree(void *p) {
 // Your code here
} 


void *myrealloc(void *p, size_t s) {
 // Your code here
}


// A couple of usefull help functions for U!
void memstat() {
  struct header * myheader;
  struct header * curheader;

  myheader = start_addr;
  
  long used = 0;
  long unused = 0;
  
  while ((size_t) myheader < (size_t) start_addr + heap_size)  {
   if (myheader->inuse == 0) unused++; else used++;
   if (myheader->next != 0) myheader = (struct header *) myheader->next;
   else break;

  }

  printf("Number of used memory blocks %i and %i unused\n\n", used, unused);
}


void dumpmem() {
  struct header * myheader;
   struct header * curheader;

   myheader = start_addr;
    
  while ((size_t) myheader < (size_t) start_addr + heap_size)  {
   printf("next addr %p\n",myheader->next);
   if (myheader->next != 0) myheader = (struct header *) myheader->next;
   else break;
  }
}
